import { Component, OnInit } from '@angular/core';
import {ApiService} from '../services/api.service';

@Component({
  selector: 'app-samples',
  templateUrl: './samples.component.html',
  styleUrls: ['./samples.component.scss']
})
export class SamplesComponent implements OnInit {  // TODO: implement paging

  materials = {};
  samples = [];
  filters = {status: 'validated'};

  constructor(
    private api: ApiService
  ) { }

  ngOnInit(): void {
    this.api.get('/materials?status=all', (mData: any) => {
      this.materials = {};
      mData.forEach(material => {
        this.materials[material._id] = material;
      });
      this.loadSamples();
    });
  }

  loadSamples() {
    this.api.get(`/samples?status=${this.filters.status}`, sData => {
      this.samples = sData as any;
      this.samples.forEach(sample => {
        sample.material_number = this.materials[sample.material_id].numbers.find(e => sample.color === e.color).number;
      });
    });
  }

}
